// Library for Microchip 23LC1024 and Arduino Mega 2560
// Chin-Shiuh Shieh on November 23, 2014

#define Microchip_23LC1024_WRMR  0x01 /* Write Mode Register */
#define Microchip_23LC1024_WRITE 0x02 /* Write data */
#define Microchip_23LC1024_READ  0x03 /* Read data */
#define Microchip_23LC1024_Byte_Mode       0x00 /* Byte mode */
#define Microchip_23LC1024_Sequential_Mode 0x40 /* Sequential mode */

void Microchip_23LC1024_Set_Mode(byte mode) {
  digitalWrite(SS,LOW);SPI.transfer(Microchip_23LC1024_WRMR);SPI.transfer(mode);digitalWrite(SS,HIGH);
};
void Microchip_23LC1024_Byte_Write(unsigned long address, byte data) {
  digitalWrite(SS,LOW);SPI.transfer(Microchip_23LC1024_WRITE);SPI.transfer((address>>16) & 0xFF);SPI.transfer((address>>8) & 0xFF);SPI.transfer(address & 0xFF);SPI.transfer(data);digitalWrite(SS,HIGH);  
};
byte Microchip_23LC1024_Byte_Read(unsigned long address) {
  byte data;
  digitalWrite(SS,LOW);SPI.transfer(Microchip_23LC1024_READ);SPI.transfer((address>>16) & 0xFF);SPI.transfer((address>>8) & 0xFF);SPI.transfer(address & 0xFF);data=SPI.transfer(0x00);digitalWrite(SS,HIGH);
  return data;  
};
void Microchip_23LC1024_Sequential_Write_Begin(unsigned long address) {
  digitalWrite(SS,LOW);SPI.transfer(Microchip_23LC1024_WRITE);SPI.transfer((address>>16) & 0xFF);SPI.transfer((address>>8) & 0xFF);SPI.transfer(address & 0xFF);
};
void Microchip_23LC1024_Sequential_Write(byte data) {
  SPI.transfer(data);
}
void Microchip_23LC1024_Sequential_Write_End(){
  digitalWrite(SS,HIGH);
}
void Microchip_23LC1024_Sequential_Read_Begin(unsigned long address) {
  digitalWrite(SS,LOW);SPI.transfer(Microchip_23LC1024_READ);SPI.transfer((address>>16) & 0xFF);SPI.transfer((address>>8) & 0xFF);SPI.transfer(address & 0xFF);
};
byte Microchip_23LC1024_Sequential_Read() {
  return(SPI.transfer(0x00));
}
void Microchip_23LC1024_Sequential_Read_End(){
  digitalWrite(SS,HIGH);
}
