// Chin-Shiuh Shieh on November 23, 2014

#include <SPI.h>
#include "Microchip_23LC1024.h"

// Arduino  <--> Microchip 23LC1024 (128KB Serial RAM)
// 50(MISO) <--> 2(SO)
// 51(MOSI) <--> 5(SI)
// 52(SCK)  <--> 6(SCK)
// 53(SS)   <--> 1(/CS)

#define MISO 50
#define MOSI 51
#define SCK  52
#define SS   53

void setup(){
  pinMode(SS,OUTPUT);digitalWrite(SS,HIGH);
  SPI.begin();SPI.setDataMode(SPI_MODE3); // Set to SPI_MODE3 is essential for Arduino MEGA 2560 and Microchip 23LC1024
  Serial.begin(9600);
}

void loop(){
  byte x; byte i; unsigned long addr;

/*
  Microchip_23LC1024_Set_Mode(Microchip_23LC1024_Byte_Mode);
  Microchip_23LC1024_Byte_Write(0x000000,0xFF);
  Serial.println(Microchip_23LC1024_Byte_Read(0x000000));
*/
/*
  Microchip_23LC1024_Set_Mode(Microchip_23LC1024_Sequential_Mode);
  Microchip_23LC1024_Sequential_Write_Begin(0x000000);
  for(i=0;i<255;i++)
    Microchip_23LC1024_Sequential_Write(i);

  Microchip_23LC1024_Sequential_Write_End();
  Microchip_23LC1024_Sequential_Read_Begin(0x000000);
  for(i=0;i<255;i++)
    Serial.println(Microchip_23LC1024_Sequential_Read());
  Microchip_23LC1024_Sequential_Read_End();
*/
  Microchip_23LC1024_Set_Mode(Microchip_23LC1024_Sequential_Mode);

  Microchip_23LC1024_Sequential_Write_Begin(0x000000);
  for(addr=0;addr<0x01FFFF;addr++)
    Microchip_23LC1024_Sequential_Write(addr%256);
  Microchip_23LC1024_Sequential_Write_End();

  Microchip_23LC1024_Sequential_Read_Begin(0x000000);
  for(addr=0;addr<0x01FFFF;addr++)
    Serial.println(Microchip_23LC1024_Sequential_Read());
   Microchip_23LC1024_Sequential_Read_End();

while(1);
}

